package cn.iocoder.yudao.module.llm.service.prompttemplatestagsbackup;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.llm.controller.admin.prompttemplatestagsbackup.vo.*;
import cn.iocoder.yudao.module.llm.dal.dataobject.prompttemplatestagsbackup.PromptTemplatesTagsBackupDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.llm.dal.mysql.prompttemplatestagsbackup.PromptTemplatesTagsBackupMapper;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.llm.enums.ErrorCodeConstants.*;

/**
 * Prompt 模板标签关系表 备份表，记录模板和标签之间的多对多关系 Service 实现类
 *
 * @author 华大大模型
 */
@Service
@Validated
public class PromptTemplatesTagsBackupServiceImpl implements PromptTemplatesTagsBackupService {

    @Resource
    private PromptTemplatesTagsBackupMapper promptTemplatesTagsBackupMapper;

    @Override
    public Long createPromptTemplatesTagsBackup(PromptTemplatesTagsBackupSaveReqVO createReqVO) {
        // 插入
        PromptTemplatesTagsBackupDO promptTemplatesTagsBackup = BeanUtils.toBean(createReqVO, PromptTemplatesTagsBackupDO.class);
        promptTemplatesTagsBackupMapper.insert(promptTemplatesTagsBackup);
        // 返回
        return promptTemplatesTagsBackup.getId();
    }

    @Override
    public void updatePromptTemplatesTagsBackup(PromptTemplatesTagsBackupSaveReqVO updateReqVO) {
        // 校验存在
        validatePromptTemplatesTagsBackupExists(updateReqVO.getId());
        // 更新
        PromptTemplatesTagsBackupDO updateObj = BeanUtils.toBean(updateReqVO, PromptTemplatesTagsBackupDO.class);
        promptTemplatesTagsBackupMapper.updateById(updateObj);
    }

    @Override
    public void deletePromptTemplatesTagsBackup(Long id) {
        // 校验存在
        validatePromptTemplatesTagsBackupExists(id);
        // 删除
        promptTemplatesTagsBackupMapper.deleteById(id);
    }

    private void validatePromptTemplatesTagsBackupExists(Long id) {
        if (promptTemplatesTagsBackupMapper.selectById(id) == null) {
            throw exception(PROMPT_TEMPLATES_TAGS_BACKUP_NOT_EXISTS);
        }
    }

    @Override
    public PromptTemplatesTagsBackupDO getPromptTemplatesTagsBackup(Long id) {
        return promptTemplatesTagsBackupMapper.selectById(id);
    }

    @Override
    public PageResult<PromptTemplatesTagsBackupDO> getPromptTemplatesTagsBackupPage(PromptTemplatesTagsBackupPageReqVO pageReqVO) {
        return promptTemplatesTagsBackupMapper.selectPage(pageReqVO);
    }

}
